import { Observable } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const fetch = (/**
 * @param {?} req
 * @param {?} httpClient
 * @return {?}
 */
(req, httpClient) => {
    /** @type {?} */
    const shouldUseBody = ['POST', 'PUT', 'PATCH'].indexOf(req.method.toUpperCase()) !== -1;
    /** @type {?} */
    const shouldStringify = (/**
     * @param {?} param
     * @return {?}
     */
    (param) => ['variables', 'extensions'].indexOf(param.toLowerCase()) !== -1);
    // `body` for some, `params` for others
    /** @type {?} */
    let bodyOrParams = {};
    if (((/** @type {?} */ (req.body))).length) {
        if (!shouldUseBody) {
            return new Observable((/**
             * @param {?} observer
             * @return {?}
             */
            observer => observer.error(new Error('Batching is not available for GET requests'))));
        }
        bodyOrParams = {
            body: req.body,
        };
    }
    else {
        if (shouldUseBody) {
            bodyOrParams = {
                body: req.body,
            };
        }
        else {
            /** @type {?} */
            const params = Object.keys(req.body).reduce((/**
             * @param {?} obj
             * @param {?} param
             * @return {?}
             */
            (obj, param) => {
                /** @type {?} */
                const value = ((/** @type {?} */ (req.body)))[param];
                obj[param] = shouldStringify(param) ? JSON.stringify(value) : value;
                return obj;
            }), {});
            bodyOrParams = { params: params };
        }
    }
    // create a request
    return httpClient.request(req.method, req.url, Object.assign({ observe: 'response', responseType: 'json', reportProgress: false }, bodyOrParams, req.options));
});
/** @type {?} */
const mergeHeaders = (/**
 * @param {?} source
 * @param {?} destination
 * @return {?}
 */
(source, destination) => {
    if (source && destination) {
        /** @type {?} */
        const merged = destination
            .keys()
            .reduce((/**
         * @param {?} headers
         * @param {?} name
         * @return {?}
         */
        (headers, name) => headers.set(name, destination.getAll(name))), source);
        return merged;
    }
    return destination || source;
});
/**
 * @template T
 * @param {...?} values
 * @return {?}
 */
function prioritize(...values) {
    /** @type {?} */
    const picked = values.find((/**
     * @param {?} val
     * @return {?}
     */
    val => typeof val !== 'undefined'));
    if (typeof picked === 'undefined') {
        return values[values.length - 1];
    }
    return picked;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { prioritize, fetch, mergeHeaders };

//# sourceMappingURL=ng.apolloLink.httpCommon.js.map